#ifndef _LIBVAUTIL_H_
#define _LIBVAUTIL_H_

#include "pap_define.h"
#include "os_type.h"


//#define sdk_log_quit_ex sdk_log_buf_lock();sdk_log_buf_date();sdk_log_buf_msg("file: %s line: %d ", __FILE__, __LINE__);sdk_log_buf_quit_unlock  /**< ӡ־,log_quitдļкŵ־ */
//#define sdk_err_quit_ex sdk_log_buf_lock();sdk_log_buf_date();sdk_log_buf_msg("file: %s line: %d ", __FILE__, __LINE__);sdk_err_buf_quit_unlock  /**< ӡ־,err_quitдļкŵ־ */



/**
	@ingroup ײ㿪
    @brief ̺߳
	@param arg ̲߳
	@retval void* ̷ֵ߳
 */
typedef void* (STDCALL* ThreadStartFunc)(void* arg);

/*FunctionMap*Start**********************************************************************************************/
#define MAP_TYPE_KEY	0
#define MAP_TYPE_INDEX	1
#define MAX_KEYWORD_LEN 32
typedef struct _FunctionMap FunctionMap;

typedef struct _KeyMapItem
{
	char key[MAX_KEYWORD_LEN];
	void* analyze_fun;	
}KeyMapItem;

typedef struct _IndexMapItem
{
	void* fun;
}IndexMapItem;


#ifndef LOADLIBRARY_OSCORE

#ifdef __cplusplus
extern "C" {
#endif

X_API void STDCALL
		my_abort();

/**
	@ingroup ʼOS
    @brief osʼ    
    @param max_cient_numֵ֧Ŀͻ˸
    @param max_server_numֵ֧ķ˸
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_cleanup
	@sa os_is_startup
 */
X_API BOOL STDCALL
sdk_os_startup(int32 max_cient_num, int32 max_server_num);

/**
	@ingroup ʼOS
    @brief osͷ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_starup
 */
X_API BOOL STDCALL
sdk_os_cleanup(void);

/**
	@ingroup 
    @brief ʼ 
    @param mutex 
    @param recursive Ƿ֧
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_mutex_free
	@note ʼѾڵһ
 */
X_API BOOL STDCALL
sdk_mutex_init(LMutex1* mutex, BOOL recursive);

/**
	@ingroup 
    @brief  
    @param recursive Ƿ֧
    @retval NULL ʧ
    @retval  ָ
	@sa LMutex
	@sa os_mutex_destroy
	@note ڲһɳʼԶos_mutex_init
 */
X_API LMutex1* STDCALL
sdk_mutex_create(BOOL recursive);

/**
	@ingroup 
    @brief ͷŻ 
    @param mutex 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LMutex
	@sa os_mutex_init
	@note ڲos_mutex_destroy
 */
X_API BOOL STDCALL
sdk_mutex_free(LMutex1* mutex);

/**
	@ingroup 
    @brief ٻ 
    @param mutex 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LMutex
	@sa os_mutex_create
	@note ٻڲ
 */
X_API BOOL STDCALL
sdk_mutex_destroy(LMutex1* mutex);

/**
	@ingroup 
    @brief 
    @param mutex 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LMutex
	@sa os_mutex_unlock
 */
X_API BOOL STDCALL
sdk_mutex_lock(LMutex1* mutex);

/**
	@ingroup 
    @brief 
    @param mutex 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LMutex
	@sa os_mutex_lock
 */
X_API BOOL STDCALL
sdk_mutex_unlock(LMutex1* mutex);

/**
	@ingroup ߳
    @brief ߳ 
    @param[out] thr ߳̾Ϊ
    @param stack_size ջС
    @param start ʼַ
    @param arg ̲߳
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LThread
	@sa ThreadStartFunc
 */
X_API BOOL STDCALL
sdk_thread_create(OUT LThread1* thr, uint32 stack_size, ThreadStartFunc start, void* arg);

/**
	@ingroup ߳
    @brief ȴ߳̽߳Դ    
    @param thr ߳̾
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LThread
 */
X_API BOOL STDCALL
sdk_thread_join(LThread1* thr);

/**
	@ingroup ߳
    @brief ̣߳ʹʱԶԴ 
    @param thr ߳̾
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa LThread
 */
X_API BOOL STDCALL
sdk_thread_detach(LThread1* thr);

/**
	@ingroup ߳
    @brief ߳id
    @retval int32 ߳id
 */
X_API void* STDCALL
sdk_thread_self(void);

/**
	@ingroup ־ӿ
    @brief ӡ־
    @param fmt ʽַ,ʽؼֲο׼Cprintfȱ׼
	@sa log_msg_ex
	@note ú־־ʱ䣬־кҪ󲻸߿ѡ
 */
X_API void STDCALL
sdk_log_msg(const char *fmt, ...);

X_API void STDCALL
sdk_log_buf_lock();

X_API void STDCALL
sdk_log_buf_date();

X_API void STDCALL
sdk_log_buf_msg(const char *fmt, ...);


#ifdef __WIN__
X_API void STDCALL
log_msg(int iLevel, char * fmt, ...);

X_API void STDCALL
log_err(int iLevel, char * fmt, ...);

X_API void STDCALL
log_debug(int iLevel, char * fmt, ...);
#endif


//
X_API void STDCALL
sdk_log_buf_msg_unlock(const char *fmt, ...);
X_API void STDCALL
sdk_err_buf_msg_unlock(const char *fmt, ...);
X_API void STDCALL
sdk_log_buf_quit_unlock(const char *fmt, ...);
X_API void STDCALL
sdk_err_buf_quit_unlock(const char *fmt, ...);

//add list by bo ---->20150604
/**
	@ingroup 
    @brief ˫    
    @param node_size ڵݵʹС
    @retval NULL ʧ 
    @retval  ָ
	@sa adt_dlist_destroy
	@sa DList
	@note node_sizeһΪĳָ͵ĴС sizeof(type*)
 */
X_API DList* STDCALL
adt_dlist_create(uint32 node_size);

/**
	@ingroup 
    @brief 
    @param dlist ָ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa adt_dlist_create
	@sa DList
	@note ÿһԪأÿһԪص
 */
X_API BOOL STDCALL
adt_dlist_destroy(DList* dlist);

/**
	@ingroup 
    @brief  
    @param dlist 
    @param node λ
    @param data 
    @retval NULL ʧ 
    @retval  ɹ
	@sa adt_dlist_add
	@sa adt_dlist_delete
	@sa DList
	@sa DListNode
	@note dataһΪָ
 */
X_API DListNode* STDCALL
adt_dlist_insert(DList* dlist, DListNode* node, void* data);

/**
	@ingroup 
    @brief  
    @param dlist 
    @param node ڸλ֮
    @param data 
    @retval NULL ʧ 
    @retval  ɹ
	@sa adt_dlist_insert
	@sa adt_dlist_delete
	@sa DList
	@sa DListNode
	@note dataһΪָ
 */
X_API DListNode* STDCALL
adt_dlist_add(DList* dlist, DListNode* node, void* data);

/**
	@ingroup 
    @brief һڵ 
    @param node ǰλ
    @retval NULL β 
    @retval  һڵ
	@sa adt_dlist_prev
	@sa DListNode
 */
X_API DListNode* STDCALL
adt_dlist_next(DListNode* node);

/**
	@ingroup 
    @brief һڵ 
    @param node ǰλ
    @retval NULL β 
    @retval  һڵ
	@sa adt_dlist_next
	@sa DListNode
 */
X_API DListNode* STDCALL
adt_dlist_prev(DListNode* node);

/**
	@ingroup 
    @brief ͷڵ 
    @param dlist 
    @retval DListNode ͷָ
	@sa adt_dlist_end
	@sa DListNode
	@sa DList
 */
X_API DListNode* STDCALL
adt_dlist_head(DList* dlist);

/**
	@ingroup 
    @brief βڵ 
    @param dlist 
    @retval DListNode βָ
	@sa adt_dlist_head
	@sa DListNode
	@sa DList
 */
X_API DListNode* STDCALL
adt_dlist_end(DList* dlist);

/**
	@ingroup 
    @brief Ԫظ 
    @param dlist 
    @retval uint32 нڵ
	@sa DList
 */
X_API uint32 STDCALL
adt_dlist_size(DList* dlist);

/**
	@ingroup 
    @brief ǷΪ 
    @param dlist 
    @retval TRUE  
    @retval FALSE ǿ
	@sa Dlist
 */
X_API BOOL STDCALL
adt_dlist_empty(DList* dlist);

/**
	@ingroup 
    @brief  ɾڵ 
    @param dlist 
    @param node ڵ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa adt_dlist_add
	@sa adt_dlist_insert
	@sa adt_dlist_delete_ex
	@sa DList
	@sa DListNode
 */
X_API BOOL STDCALL
adt_dlist_delete(DList* dlist, DListNode* node);

/**
	@ingroup 
    @brief  ɾڵ,һڵ
    @param dlist 
    @param node ڵ
    @retval nodeڵһڵ
	@sa adt_dlist_delete
	@sa adt_dlist_add
	@sa adt_dlist_insert
	@sa DList
	@sa DListNode
 */
X_API DListNode* STDCALL
adt_dlist_delete_ex(DList* dlist, DListNode* node);

/**
	@ingroup 
    @brief ýڵ  
    @param node ڵ
    @retval NULL ʧ 
    @retval  ڵ
	@sa adt_dlist_add
	@sa adt_dlist_insert
	@sa DList
	@sa DListNode
	@note ֵһΪָ
 */
X_API void* STDCALL
adt_dlist_getdata(DListNode* node);

/**
	@ingroup 
    @brief  
    @param dlist 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa DList
	@sa adt_dlist_unlock
 */
X_API BOOL STDCALL
adt_dlist_lock(DList* dlist);

/**
	@ingroup 
    @brief  
    @param dlist 
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa DList
	@sa adt_dlist_lock
 */
X_API BOOL STDCALL
adt_dlist_unlock(DList* dlist);


//Эʼ 
X_API TProtFrame* STDCALL
pap_init();

//Эʼ 
X_API int STDCALL
pap_uninit(TProtFrame* frame);

//עЭص
X_API int STDCALL 
pap_regist_cbk_cmd_analyze(TProtFrame* frame, const char* cmdkey, CallBackAnalyze cbfuc);

X_API int STDCALL 
pap_regist_cbk_cmd_analyze_spe(TProtFrame* frame, const char* cmdkey, CallBackAnalyze cbfuc);

//עЭ鴦ص
X_API int STDCALL 
pap_regist_cbk_cmd_deal(TProtFrame* frame, const char* cmdkey, CallBackKeyCmd cbfuc);

X_API int STDCALL 
pap_regist_cbk_cmd_deal_spe(TProtFrame* frame, const char* cmdkey, CallBackKeyCmd cbfuc);

//עȡص
X_API int STDCALL 
pap_regist_cbk_get_param(TProtFrame* frame, CallBackGetParam cbfuc);

//Э
X_API int STDCALL 
pap_run_cmd(TProtFrame* frame, const char* text, const int len, void* user);

//нЭݰ
X_API int STDCALL 
pap_run_cmd_package(TProtFrame* frame, const char* package, const int len, void* udata);

X_API FunctionMap* STDCALL
function_map_create(int type);

/*ؼӳ亯********************************************************/
X_API FunctionMap* STDCALL 
function_map_create_key();

/*ӳ亯********************************************************/
X_API FunctionMap* STDCALL 
function_map_create_index(int max_index);

/*ٹؼӳ亯*******************************************************/
X_API int STDCALL 
function_map_destroy(FunctionMap* map);

/*ӹؼӳ亯******************************************************/
X_API int STDCALL 
function_map_bind_key(FunctionMap* map, char* key, void* func);

/*ӳ亯*****************************************************/
X_API int STDCALL 
function_map_bind_index(FunctionMap* map, int index, void* func);

/*ȡ******************************************************/
X_API KeyMapItem* STDCALL 
function_map_get_key_map(FunctionMap* map, char* key);

/*ȡ*********************************************************/
X_API IndexMapItem* STDCALL 
function_map_get_index_map(FunctionMap* map, int index);
/*FunctionMap*End**********************************************************************************************/


X_API NetLink* STDCALL
net_link_create();

X_API int STDCALL
net_link_destroy(NetLink* link);

X_API int STDCALL
net_link_set_udata(NetLink* link, void* udata);

X_API int STDCALL
net_link_get_udata(NetLink* link, void** udata);

X_API int STDCALL
net_link_bind_parase_protocol(NetLink* link, NetRecvProtocolFunc recv_protocol);

X_API int STDCALL 
net_link_set_core(NetLink* link, NetTcpClient* client);

X_API int STDCALL
net_link_time_add(NetLink* link);

X_API BOOL STDCALL 
net_link_check_timeout(NetLink* link);

X_API int STDCALL
net_link_send_command(NetLink* link, char* data, int len);

X_API int STDCALL
net_link_send_data(NetLink* link, char* data, int len);

X_API int STDCALL
net_link_send_package(NetLink* link, char* package, int len); //ݣѾ

X_API int STDCALL 
net_link_set_type(NetLink* link, int type);

X_API int STDCALL 
net_link_get_type(NetLink* link);

X_API int STDCALL 
net_link_get_remote(NetLink* link, OUT char* ip, OUT uint16* port);


X_API BOOL STDCALL
inner_sdk_os_startup(int32 max_cient_num, int32 max_server_num);

X_API BOOL STDCALL
inner_sdk_os_cleanup(void);

/**
	@ingroup ʱ
    @brief ʱ 
    @param func ʱ
    @param tm ʱʱ
    @param cxt û 
    @retval NULL ʧ 
    @retval  ʱ
	@sa os_timer_destroy
	@sa LTimer
	@sa OnTimerFunc
	@note ʱС1룬С1Ч
 */
X_API LTimer* STDCALL
sdk_timer_create(OsTimerFunc func, uint32 tm, void* cxt);

/**
	@ingroup ʱ
    @brief ٶʱ 
    @param timer ʱ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_timer_create
	@sa LTimer
 */
X_API BOOL STDCALL
sdk_timer_destroy(LTimer* timer);

/**
	@ingroup TCP
    @brief TcpServer 
    @retval NULL ʧ 
    @retval  TcpServerָ
	@sa os_tcp_server_destroy
	@sa TcpServer
 */
X_API NetTcpServer* STDCALL
net_tcp_server_create(void);

/**
	@ingroup TCP
    @brief TcpServer 
    @param server TcpServer,os_tcp_server_createֵ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_server_create
	@sa TcpServer
 */
X_API BOOL STDCALL
net_tcp_server_destroy(NetTcpServer* server);

/**
	@ingroup TCP
    @brief ñϢ 
    @param server TcpServer,os_tcp_server_createֵ
    @param ip ipַ
    @param port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpServer
	@sa os_tcp_server_get_local
 */
X_API BOOL STDCALL
net_tcp_server_set_local(NetTcpServer* server, char* ip, uint16 port);

/**
	@ingroup TCP
    @brief ñϢ 
    @param server TcpServer,os_tcp_server_createֵ
    @param[out] ip ipַ
    @param[out] port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpServer
	@sa os_tcp_server_set_local
 */
X_API BOOL STDCALL
net_tcp_server_get_local(NetTcpServer* server, OUT char* ip, OUT uint16* port);

/**
	@ingroup TCP
    @brief ״̬ 
    @param server TcpServer,os_tcp_server_createֵ
    @retval SERVER_STATUS_DISLISTEN      δ
    @retval SERVER_STATUS_LISTEN         Ѽ
    @retval SERVER_STATUS_DISLISTENING   ڹرռ    
    @retval -1  ʧ
	@sa TcpServer
 */
X_API int32 STDCALL
net_tcp_server_get_status(NetTcpServer* server);

/**
	@ingroup TCP
    @brief ʼ 
    @param server TcpServer,os_tcp_server_createֵ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpServer
	@sa os_tcp_server_close
 */
X_API BOOL STDCALL
net_tcp_server_open(NetTcpServer* server);

/**
	@ingroup TCP
    @brief ֹͣ 
    @param server TcpServer,os_tcp_server_createֵ
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpServer
	@sa os_tcp_server_open
 */
X_API BOOL STDCALL
net_tcp_server_close(NetTcpServer* server);

/**
	@ingroup TCP
    @brief Accpteص 
    @param server TcpServer
    @param accept ص
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpServer
	@sa OnServerAcceptFunc
 */
X_API BOOL STDCALL
net_tcp_server_bind_accept(NetTcpServer* server, NetServerAcceptFunc accept, void* udata);

/**
	@ingroup TCP
    @brief TcpClient
    @retval NULL ʧ 
    @retval  TcpClientָ
	@sa os_tcp_client_destroy
	@sa TcpClient
 */
X_API NetTcpClient* STDCALL
net_tcp_client_create(void);

/**
	@ingroup TCP
    @brief TcpClient 
    @param client TcpClient
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_client_create
	@sa TcpClient
 */
X_API BOOL STDCALL
net_tcp_client_destroy(NetTcpClient* client);

/**
	@ingroup TCP
    @brief Զ 
    @param client TcpClient
    @param ip ipַ
    @param port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_client_get_remote
	@sa TcpClient
 */
X_API BOOL STDCALL
net_tcp_client_set_remote(NetTcpClient* client, char* ip, uint16 port);

/**
	@ingroup TCP
    @brief Զ 
    @param client TcpClient
    @param[out] ip ipַ
    @param[out] port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_client_set_remote
	@sa TcpClient
 */
X_API BOOL STDCALL
net_tcp_client_get_remote(NetTcpClient* client, OUT char* ip, OUT uint16* port);

/**
	@ingroup TCP
    @brief ñ 
    @param client TcpClient
    @param[out] ip ipַ
    @param[out] port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_client_set_local
	@sa TcpClient
 */
X_API BOOL STDCALL
net_tcp_client_get_local(NetTcpClient* client, OUT char* ip, OUT uint16* port);

/**
	@ingroup TCP
    @brief ñ 
    @param client TcpClient
    @param ip ipַ
    @param port ˿
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa os_tcp_client_get_local
 */
X_API BOOL STDCALL
net_tcp_client_set_local(NetTcpClient* client, char* ip, uint16 port);

/**
	@ingroup TCP
    @brief TcpClient״̬ 
    @param client TcpClient
    @retval CLIENT_STATUS_DISCONNECT     Ͽ
    @retval CLIENT_STATUS_CONNECTING     
    @retval CLIENT_STATUS_CONNECT        
    @retval CLIENT_STATUS_DISCONNECTING  ڶϿ 
    @retval -1 ʧ
 */
X_API int32 STDCALL
net_tcp_client_get_status(NetTcpClient* client);

/**
	@ingroup TCP
    @brief  
    @param client TcpClient
    @param sock socket, -1ʾ½socket, ʾʹsocket(serverʹ)
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa os_tcp_client_close
	@sa TcpClient
 */

#ifdef __WIN__
X_API BOOL STDCALL
net_tcp_client_open(NetTcpClient* client, SOCKET sock);
#else
X_API BOOL STDCALL
net_tcp_client_open(NetTcpClient* client, int sock);
#endif


/**
	@ingroup TCP
    @brief ر 
    @param client TcpClient
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa os_tcp_client_open
 */
X_API BOOL STDCALL
net_tcp_client_close(NetTcpClient* client);

/**
	@ingroup TCP
    @brief     
    @param client TcpClient 
    @param data ָ
    @param len ݴС
    @retval 0  
    @retval -1 ʧ 
    @retval  ʵʷͳ
	@sa os_tcp_client_read
 */
X_API int32 STDCALL
net_tcp_client_send(NetTcpClient* client, char* data, uint32 len);

/**
	@ingroup TCP
    @brief ȡ 
    @param client TcpClient
    @param data ָ
    @param size ݴС
    @retval -1 ʧ 
    @retval 0  
    @retval  صֽ
	@sa os_tcp_client_send
 */
X_API int32 STDCALL
net_tcp_client_read(NetTcpClient* client, char* data, uint32 len);

/**
	@ingroup TCP
    @brief û 
    @param client TcpClient
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa os_tcp_client_get_udata
 */
X_API BOOL STDCALL
net_tcp_client_set_udata(NetTcpClient* client, void* udata);

/**
	@ingroup TCP
    @brief û 
    @param client TcpClient
    @retval void* û
	@sa TcpClient
	@sa os_tcp_client_set_udata
 */
X_API void* STDCALL
net_tcp_client_get_udata(NetTcpClient* client);

/**
	@ingroup TCP
    @brief ӻص 
    @param client TcpClient
    @param connect ص
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa OnClientConnectFunc
 */
X_API BOOL STDCALL
net_tcp_client_bind_connect(NetTcpClient* client, NetClientConnectFunc connect, void* udata);

/**
	@ingroup TCP
    @brief 󶨶Ͽӻص 
    @param client TcpClient
    @param disconnect ص
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa OnClientDisconnectFunc
 */
X_API BOOL STDCALL
net_tcp_client_bind_disconnect(NetTcpClient* client, NetClientDisconnectFunc disconnect, void* udata);

/**
	@ingroup TCP
    @brief 󶨶ȡݻص 
    @param client TcpClient
    @param read ص
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa OnClientReadFunc
 */
X_API BOOL STDCALL
net_tcp_client_bind_read(NetTcpClient* client, NetClientReadFunc read, void* udata);

/**
	@ingroup TCP
    @brief дݻص 
    @param client TcpClient
    @param write ص
    @param udata û
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
	@sa OnClientWriteFunc
 */
X_API BOOL STDCALL
net_tcp_client_bind_write(NetTcpClient* client, NetClientWriteFunc write, void* udata);

/**
	@ingroup TCP
    @brief ÿͻ˽ջС
    @param client TcpClient
    @param buf_len С
    @retval TRUE ɹ 
    @retval FALSE ʧ
	@sa TcpClient
 */
X_API BOOL STDCALL
net_tcp_client_set_rcvbuf_len(NetTcpClient* client, int buf_len);

X_API BOOL STDCALL
sdk_main_lock(void);

X_API BOOL STDCALL
sdk_main_unlock(void);

X_API void STDCALL
sdk_os_sleep(int32 i);

#ifdef __cplusplus
}
#endif

#else

#define OS_TYPEDEF_INT_FUNCTION(funcName)	typedef int (STDCALL* pf##funcName)
#define OS_TYPEDEF_BOOL_FUNCTION(funcName)	typedef BOOL (STDCALL* pf##funcName)
#define OS_TYPEDEF_VOID_FUNCTION(funcName)	typedef void (STDCALL* pf##funcName)
#define OS_DECLARE_FUNCTION(funcName)	extern pf##funcName funcName
#define OS_IMPLEMENT_FUNCTION(funcName)  pf##funcName funcName = NULL
#define OS_EXPORT_FUNCTION(hDll, funcName)	funcName = (pf##funcName)::GetProcAddress(hDll, #funcName);

namespace OSSDK_API
{
	int 	LoadOSSDK();
	int 	LoadOsSdkByModuleName(char* _pcModuleName);
	bool    ReleaseOSSDK();

	OS_TYPEDEF_BOOL_FUNCTION(sdk_os_startup)(int32 max_cient_num, int32 max_server_num);
	OS_DECLARE_FUNCTION(sdk_os_startup);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_os_cleanup)(void);
	OS_DECLARE_FUNCTION(sdk_os_cleanup);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_mutex_init)(LMutex1* mutex, BOOL recursive);
	OS_DECLARE_FUNCTION(sdk_mutex_init);

	typedef LMutex1* (STDCALL* pfsdk_mutex_create)(BOOL recursive);
	OS_DECLARE_FUNCTION(sdk_mutex_create);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_mutex_free)(LMutex1* mutex);
	OS_DECLARE_FUNCTION(sdk_mutex_free);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_mutex_destroy)(LMutex1* mutex);
	OS_DECLARE_FUNCTION(sdk_mutex_destroy);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_mutex_lock)(LMutex1* mutex);
	OS_DECLARE_FUNCTION(sdk_mutex_lock);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_mutex_unlock)(LMutex1* mutex);
	OS_DECLARE_FUNCTION(sdk_mutex_unlock);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_thread_create)(OUT LThread1* thr, uint32 stack_size, ThreadStartFunc start, void* arg);
	OS_DECLARE_FUNCTION(sdk_thread_create);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_thread_join)(LThread1* thr);
	OS_DECLARE_FUNCTION(sdk_thread_join);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_thread_detach)(LThread1* thr);
	OS_DECLARE_FUNCTION(sdk_thread_detach);

	OS_TYPEDEF_INT_FUNCTION(sdk_thread_self)(void);
	OS_DECLARE_FUNCTION(sdk_thread_self);

	OS_TYPEDEF_VOID_FUNCTION(sdk_log_msg)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_log_msg);

	OS_TYPEDEF_VOID_FUNCTION(sdk_log_buf_lock)();
	OS_DECLARE_FUNCTION(sdk_log_buf_lock);

	OS_TYPEDEF_VOID_FUNCTION(sdk_log_buf_date)();
	OS_DECLARE_FUNCTION(sdk_log_buf_date);

	OS_TYPEDEF_VOID_FUNCTION(sdk_log_buf_msg)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_log_buf_msg);


	OS_TYPEDEF_VOID_FUNCTION(sdk_log_buf_msg_unlock)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_log_buf_msg_unlock);

	OS_TYPEDEF_VOID_FUNCTION(sdk_log_buf_quit_unlock)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_log_buf_quit_unlock);

	OS_TYPEDEF_VOID_FUNCTION(sdk_err_buf_msg_unlock)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_err_buf_msg_unlock);

	OS_TYPEDEF_VOID_FUNCTION(sdk_err_buf_quit_unlock)(const char *fmt, ...);
	OS_DECLARE_FUNCTION(sdk_err_buf_quit_unlock);

	typedef DList* (STDCALL* pfadt_dlist_create)(uint32 node_size);
	OS_DECLARE_FUNCTION(adt_dlist_create);

	OS_TYPEDEF_BOOL_FUNCTION(adt_dlist_destroy)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_destroy);

	typedef DListNode* (STDCALL* pfadt_dlist_insert)(DList* dlist, DListNode* node, void* data);
	OS_DECLARE_FUNCTION(adt_dlist_insert);

	typedef DListNode* (STDCALL* pfadt_dlist_add)(DList* dlist, DListNode* node, void* data);
	OS_DECLARE_FUNCTION(adt_dlist_add);

	typedef DListNode* (STDCALL* pfadt_dlist_next)(DListNode* node);
	OS_DECLARE_FUNCTION(adt_dlist_next);

	typedef DListNode* (STDCALL* pfadt_dlist_prev)(DListNode* node);
	OS_DECLARE_FUNCTION(adt_dlist_prev);

	typedef DListNode* (STDCALL* pfadt_dlist_head)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_head);

	typedef DListNode* (STDCALL* pfadt_dlist_end)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_end);

	OS_TYPEDEF_INT_FUNCTION(adt_dlist_size)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_size);

	OS_TYPEDEF_BOOL_FUNCTION(adt_dlist_empty)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_empty);

	OS_TYPEDEF_BOOL_FUNCTION(adt_dlist_delete)(DList* dlist, DListNode* node);
	OS_DECLARE_FUNCTION(adt_dlist_delete);

	typedef DListNode* (STDCALL* pfadt_dlist_delete_ex)(DList* dlist, DListNode* node);
	OS_DECLARE_FUNCTION(adt_dlist_delete_ex);

	typedef void* (STDCALL* pfadt_dlist_getdata)(DListNode* node);
	OS_DECLARE_FUNCTION(adt_dlist_getdata);

	OS_TYPEDEF_BOOL_FUNCTION(adt_dlist_lock)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_lock);

	OS_TYPEDEF_BOOL_FUNCTION(adt_dlist_unlock)(DList* dlist);
	OS_DECLARE_FUNCTION(adt_dlist_unlock);

	typedef TProtFrame* (STDCALL* pfpap_init)();
	OS_DECLARE_FUNCTION(pap_init);

	OS_TYPEDEF_INT_FUNCTION(pap_uninit)(TProtFrame* frame);
	OS_DECLARE_FUNCTION(pap_uninit);

	OS_TYPEDEF_INT_FUNCTION(pap_regist_cbk_cmd_analyze)(TProtFrame* frame, const char* cmdkey, CallBackAnalyze cbfuc);
	OS_DECLARE_FUNCTION(pap_regist_cbk_cmd_analyze);

	OS_TYPEDEF_INT_FUNCTION(pap_regist_cbk_cmd_analyze_spe)(TProtFrame* frame, const char* cmdkey, CallBackAnalyze cbfuc);
	OS_DECLARE_FUNCTION(pap_regist_cbk_cmd_analyze_spe);

	OS_TYPEDEF_INT_FUNCTION(pap_regist_cbk_cmd_deal)(TProtFrame* frame, const char* cmdkey, CallBackKeyCmd cbfuc);
	OS_DECLARE_FUNCTION(pap_regist_cbk_cmd_deal);

	OS_TYPEDEF_INT_FUNCTION(pap_regist_cbk_cmd_deal_spe)(TProtFrame* frame, const char* cmdkey, CallBackKeyCmd cbfuc);
	OS_DECLARE_FUNCTION(pap_regist_cbk_cmd_deal_spe);

	OS_TYPEDEF_INT_FUNCTION(pap_regist_cbk_get_param)(TProtFrame* frame, CallBackGetParam cbfuc);
	OS_DECLARE_FUNCTION(pap_regist_cbk_get_param);

	OS_TYPEDEF_INT_FUNCTION(pap_run_cmd)(TProtFrame* frame, const char* text, const int len, void* user);
	OS_DECLARE_FUNCTION(pap_run_cmd);

	OS_TYPEDEF_INT_FUNCTION(pap_run_cmd_package)(TProtFrame* frame, const char* package, const int len, void* udata);
	OS_DECLARE_FUNCTION(pap_run_cmd_package);

	typedef FunctionMap* (STDCALL* pffunction_map_create)(int type);
	OS_DECLARE_FUNCTION(function_map_create);

	typedef FunctionMap* (STDCALL* pffunction_map_create_key)();
	OS_DECLARE_FUNCTION(function_map_create_key);

	typedef FunctionMap* (STDCALL* pffunction_map_create_index)(int max_index);
	OS_DECLARE_FUNCTION(function_map_create_index);

	OS_TYPEDEF_INT_FUNCTION(function_map_destroy)(FunctionMap* map);
	OS_DECLARE_FUNCTION(function_map_destroy);

	OS_TYPEDEF_INT_FUNCTION(function_map_bind_key)(FunctionMap* map, char* key, void* func);
	OS_DECLARE_FUNCTION(function_map_bind_key);

	OS_TYPEDEF_INT_FUNCTION(function_map_bind_index)(FunctionMap* map, int index, void* func);
	OS_DECLARE_FUNCTION(function_map_bind_index);

	typedef KeyMapItem* (STDCALL* pffunction_map_get_key_map)(FunctionMap* map, char* key);
	OS_DECLARE_FUNCTION(function_map_get_key_map);

	typedef IndexMapItem* (STDCALL* pffunction_map_get_index_map)(FunctionMap* map, int index);
	OS_DECLARE_FUNCTION(function_map_get_index_map);

	typedef NetLink* (STDCALL* pfnet_link_create)();
	OS_DECLARE_FUNCTION(net_link_create);

	OS_TYPEDEF_INT_FUNCTION(net_link_destroy)(NetLink* link);
	OS_DECLARE_FUNCTION(net_link_destroy);

	OS_TYPEDEF_INT_FUNCTION(net_link_set_udata)(NetLink* link, void* udata);
	OS_DECLARE_FUNCTION(net_link_set_udata);

	OS_TYPEDEF_INT_FUNCTION(net_link_get_udata)(NetLink* link, void** udata);
	OS_DECLARE_FUNCTION(net_link_get_udata);

	OS_TYPEDEF_INT_FUNCTION(net_link_bind_parase_protocol)(NetLink* link, NetRecvProtocolFunc recv_protocol);
	OS_DECLARE_FUNCTION(net_link_bind_parase_protocol);

	OS_TYPEDEF_INT_FUNCTION(net_link_set_core)(NetLink* link, NetTcpClient* client);
	OS_DECLARE_FUNCTION(net_link_set_core);

	OS_TYPEDEF_INT_FUNCTION(net_link_time_add)(NetLink* link);
	OS_DECLARE_FUNCTION(net_link_time_add);

	OS_TYPEDEF_BOOL_FUNCTION(net_link_check_timeout)(NetLink* link);
	OS_DECLARE_FUNCTION(net_link_check_timeout);

	OS_TYPEDEF_INT_FUNCTION(net_link_send_command)(NetLink* link, char* data, int len);
	OS_DECLARE_FUNCTION(net_link_send_command);

	OS_TYPEDEF_INT_FUNCTION(net_link_send_data)(NetLink* link, char* data, int len);
	OS_DECLARE_FUNCTION(net_link_send_data);

	OS_TYPEDEF_INT_FUNCTION(net_link_send_package)(NetLink* link, char* package, int len);//ݣѾ
	OS_DECLARE_FUNCTION(net_link_send_package);

	OS_TYPEDEF_INT_FUNCTION(net_link_set_type)(NetLink* link, int type);//ݣѾ
	OS_DECLARE_FUNCTION(net_link_set_type);

	OS_TYPEDEF_INT_FUNCTION(net_link_get_type)(NetLink* link);
	OS_DECLARE_FUNCTION(net_link_get_type);

	OS_TYPEDEF_INT_FUNCTION(net_link_get_type)(NetLink* link);
	OS_DECLARE_FUNCTION(net_link_get_type);

	OS_TYPEDEF_INT_FUNCTION(net_link_get_remote)(NetLink* link, OUT char* ip, OUT uint16* port);
	OS_DECLARE_FUNCTION(net_link_get_remote);

	typedef LTimer* (STDCALL* pfsdk_timer_create)(OsTimerFunc func, uint32 tm, void* cxt);
	OS_DECLARE_FUNCTION(sdk_timer_create);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_timer_destroy)(LTimer* timer);
	OS_DECLARE_FUNCTION(sdk_timer_destroy);

	typedef NetTcpServer* (STDCALL* pfnet_tcp_server_create)(void);
	OS_DECLARE_FUNCTION(net_tcp_server_create);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_destroy)(NetTcpServer* server);
	OS_DECLARE_FUNCTION(net_tcp_server_destroy);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_set_local)(NetTcpServer* server, char* ip, uint16 port);
	OS_DECLARE_FUNCTION(net_tcp_server_set_local);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_get_local)(NetTcpServer* server, OUT char* ip, OUT uint16* port);
	OS_DECLARE_FUNCTION(net_tcp_server_get_local);

	OS_TYPEDEF_INT_FUNCTION(net_tcp_server_get_status)(NetTcpServer* server);
	OS_DECLARE_FUNCTION(net_tcp_server_get_status);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_open)(NetTcpServer* server);
	OS_DECLARE_FUNCTION(net_tcp_server_open);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_close)(NetTcpServer* server);
	OS_DECLARE_FUNCTION(net_tcp_server_close);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_server_bind_accept)(NetTcpServer* server, NetServerAcceptFunc accept, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_server_bind_accept);

	typedef NetTcpClient* (STDCALL* pfnet_tcp_client_create)(void);
	OS_DECLARE_FUNCTION(net_tcp_client_create);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_destroy)(NetTcpClient* client);
	OS_DECLARE_FUNCTION(net_tcp_client_destroy);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_set_remote)(NetTcpClient* client, char* ip, uint16 port);
	OS_DECLARE_FUNCTION(net_tcp_client_set_remote);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_get_remote)(NetTcpClient* client, OUT char* ip, OUT uint16* port);
	OS_DECLARE_FUNCTION(net_tcp_client_get_remote);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_get_local)(NetTcpClient* client, OUT char* ip, OUT uint16* port);
	OS_DECLARE_FUNCTION(net_tcp_client_get_local);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_set_local)(NetTcpClient* client, char* ip, uint16 port);
	OS_DECLARE_FUNCTION(net_tcp_client_set_local);

	OS_TYPEDEF_INT_FUNCTION(net_tcp_client_get_status)(NetTcpClient* client);
	OS_DECLARE_FUNCTION(net_tcp_client_get_status);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_open)(NetTcpClient* client, SOCKET sock);
	OS_DECLARE_FUNCTION(net_tcp_client_open);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_close)(NetTcpClient* client);
	OS_DECLARE_FUNCTION(net_tcp_client_close);

	OS_TYPEDEF_INT_FUNCTION(net_tcp_client_send)(NetTcpClient* client, char* data, uint32 len);
	OS_DECLARE_FUNCTION(net_tcp_client_send);

	OS_TYPEDEF_INT_FUNCTION(net_tcp_client_read)(NetTcpClient* client, char* data, uint32 len);
	OS_DECLARE_FUNCTION(net_tcp_client_read);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_set_udata)(NetTcpClient* client, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_client_set_udata);

	typedef void* (STDCALL* pfnet_tcp_client_get_udata)(NetTcpClient* client);
	OS_DECLARE_FUNCTION(net_tcp_client_get_udata);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_bind_connect)(NetTcpClient* client, NetClientConnectFunc connect, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_client_bind_connect);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_bind_disconnect)(NetTcpClient* client, NetClientDisconnectFunc disconnect, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_client_bind_disconnect);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_bind_read)(NetTcpClient* client, NetClientReadFunc read, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_client_bind_read);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_bind_write)(NetTcpClient* client, NetClientWriteFunc write, void* udata);
	OS_DECLARE_FUNCTION(net_tcp_client_bind_write);

	OS_TYPEDEF_BOOL_FUNCTION(net_tcp_client_set_rcvbuf_len)(NetTcpClient* client, int buf_len);
	OS_DECLARE_FUNCTION(net_tcp_client_set_rcvbuf_len);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_main_lock)(void);
	OS_DECLARE_FUNCTION(sdk_main_lock);

	OS_TYPEDEF_BOOL_FUNCTION(sdk_main_unlock)(void);
	OS_DECLARE_FUNCTION(sdk_main_unlock);

	OS_TYPEDEF_VOID_FUNCTION(sdk_os_sleep)(int32 i);
	OS_DECLARE_FUNCTION(sdk_os_sleep);

	OS_TYPEDEF_VOID_FUNCTION(log_msg)(int iLevel, char * fmt, ...);
	OS_DECLARE_FUNCTION(log_msg);
	
	OS_TYPEDEF_VOID_FUNCTION(log_err)(int iLevel, char * fmt, ...);
	OS_DECLARE_FUNCTION(log_err);

	OS_TYPEDEF_VOID_FUNCTION(log_debug)(int iLevel, char * fmt, ...);
	OS_DECLARE_FUNCTION(log_debug);
	//
#ifndef LIBSTREAMPROC_EXPORTS //libstreamproc ˽ӿ
#include "libstreamtypes.h"
	OS_TYPEDEF_INT_FUNCTION(SA_GetUserDataInfoEx)(UserDataInParam* _pInParam, int _iInLen, OUT void* _pvOutBuf, int _iBufLen);
	OS_DECLARE_FUNCTION(SA_GetUserDataInfoEx);

	OS_TYPEDEF_INT_FUNCTION(SA_DecryptOneFrame)(unsigned char* _pucFrameBuf, int _iFrameLen, unsigned char* _pucDecryptKey, int _iKeyLen);
	OS_DECLARE_FUNCTION(SA_DecryptOneFrame);
#endif
}

using namespace OSSDK_API;

#endif

#define sdk_log_err_ex sdk_log_buf_lock();sdk_log_buf_date();sdk_log_buf_msg("file: %s line: %d ", __FILE__, __LINE__);sdk_err_buf_msg_unlock  /**< ӡ־,err_msgдļкŵ־ */

#endif

